#!/bin/bash

ITERATION=$1

declare -a NB_BYTES=('4096' '40960' '409600');
declare -a NB_TRANSFER=('1' '10' '100');

echo P100 > multiple_test.csv

for j in `seq 0 3`;
do
    echo NB_BYTES,${NB_BYTES[$j]}, >> multiple_test.csv
    for i in `seq 1 $ITERATION`;
    do
	CUDA_VISIBLE_DEVICES=0 ./multiple_test ${NB_BYTES[$j]} ${NB_TRANSFER[$j]}  
    	echo , >> multiple_test.csv
    done
done

echo \ >> multiple_test.csv
echo K40 >> multiple_test.csv

for j in `seq 0 3`;
do
    echo NB_BYTES,${NB_BYTES[$j]}, >> multiple_test.csv
    for i in `seq 1 $ITERATION`;
    do
	CUDA_VISIBLE_DEVICES=1 ./multiple_test ${NB_BYTES[$j]} ${NB_TRANSFER[$j]}  
    	echo , >> multiple_test.csv
    done
done

cat multiple_test.csv | tr -d \\n > multiple_test.export.csv
# sed -i 's/P100/'P100\\n'/' multiple_test.export.csv
 sed -i 's/K40/'\\n\\nK40'/' multiple_test.export.csv

for k in `seq 0 3`;
do
    echo $k
    sed -i "s/NB_BYTES,${NB_BYTES[$k]},/\\nNB_BYTES,${NB_BYTES[$k]}\\n/g" multiple_test.export.csv
done
